require("kara3d.vector")
require("kara3d.matrix")
require("kara3d.quaternion")
require("kara3d.transform")
require("utils")

-- ********** DEFINITION AND GENERIC FUNCTIONS **********

light = {class = "light"}
light.__index = light

-- Creates a new light with transform t and RGB value diff and spec
function light.new(t, diff, spec)
  diff = diff and vector.new(diff) or 255 * vector.one(3)
  spec = spec and vector.new(spec) or 255 * vector.one(3)
  local l = {transform = t, diffuse = diff, specular = spec}
  setmetatable(l, light)
  return l
end

-- Clones this light
function light:clone()
  return light.new(self.transform, self.diffuse:clone(), self.specular:clone())
end
